Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
	' This sample now uses the AIOWDM.bas VB module included in this project
	' Calls to OutPortB() InPortB() have been changed to RelOutPortB() RelInPortB()
	' They now use CardNum = 0, and address "Offset" instead of just "Address"
	' This app will write output to A and also read its value as input, It also reads Input on B
	' It only supports a single card installed in the system
	
	Public Status As Short
	Public NumCards As Integer
	Public Cardnum As Short
	
	Dim Ports(5) As Integer
	Public RunFlag As Boolean
	Public Offset As Integer
	Public MyIndex As Short
	Dim MyValues(2) As Short
	Public Msg As String
	
	'UPGRADE_WARNING: Event AddressList.SelectedIndexChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub AddressList_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles AddressList.SelectedIndexChanged
		Dim NewAddress As Integer
		NewAddress = Ports(AddressList.SelectedIndex)
		If NewAddress <> Offset Then
			Offset = NewAddress
			Memo1.Text = Memo1.Text & "New Port Selected: " & AddressList.Text & Chr(13) & Chr(10)
			Memo1.SelectionStart = 32768
		End If
	End Sub
	
	Private Sub ExitButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitButton.Click
		End
	End Sub
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Memo1.Text = "This sample outputs a walking bit on Port A of the selected group. It then reads back the value from Port A.  This should be identical to the output value due to on-chip readback. It also displays the Input from Port B.  If a wrap plug is installed, Port B should read the same value.  Otherwise, ground individual bits on Port B to see them show zeroes on the display." & Chr(13) & Chr(10)
		Memo1.SelectionStart = 32768
		
		Dim found As Boolean
		Dim DeviceID As Integer
		Dim Base As Integer
		Dim NameSize As Integer
		'UPGRADE_NOTE: Name was upgraded to Name_Renamed. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Name_Renamed As String
		Dim i As Short
		
		NumCards = 0
		Cardnum = 0
		DeviceID = 0
		NameSize = 256
		
		found = False
		RunFlag = True
		
		'This is still an absolute port address value writen to the driver to test for card and error return 0xAA55
		If (InPortB(&H61) = &HAA55) Then
			Call MsgBox("AIOWDM.SYS not detected. Please copy AIOWDM.SYS into C:\WINDOWS\system32\drivers directory or for Win7 C:\Windows\SysWOW64\drivers and re-run this sample.", 0, "Warning")
		End If
		
		'Make sure theres at least one card in the system
		NumCards = GetNumCards()
		If (NumCards = 0) Then GoTo NoCards
		
		'Samples are for only one card get the device ID
		Status = QueryCardInfo(i, DeviceID, Base, NameSize, Name_Renamed)
		
		'Validate then save the card name and address offsets here:
		Select Case DeviceID
			
			' DIO offsets +4 each decimal 0,4,8,12,16
			
			Case &HECA9
				CardName.Text = "PCI-A12-16 Analog I/O Card with Digital"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H10 ' These boards have an 0x10 offset to the DIO chip
				found = True
			Case &HECAA
				CardName.Text = "PCI-A12-16A Analog I/O Card with Digital"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H10 ' These boards have an 0x10 offset to the DIO chip
				found = True
			Case &H2C58
				CardName.Text = "PCI-DIO-96C3 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				found = True
			Case &H2C50
				CardName.Text = "PCI-DIO-96CT Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				found = True
			Case &H2C70
				CardName.Text = "PCI-DIO-96CT Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				found = True
			Case &HC50
				CardName.Text = "PCI-DIO-24H Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HC51
				CardName.Text = "PCI-DIO-24D Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE51
				CardName.Text = "PCI-DIO-24H(C) Parallel Digital I/O Card w/Counter"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE52
				CardName.Text = "PCI-DIO-24D(C) Parallel Digital I/O Card w/Counter"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
				
			Case &HE50
				CardName.Text = "PCI-DIO-24S Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HC60
				CardName.Text = "PCI-DIO-48 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				Ports(0) = &H0
				Ports(1) = &H4
				found = True
			Case &HE60
				CardName.Text = "PCI-DIO-48S Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				Ports(0) = &H0
				Ports(1) = &H4
				found = True
				
			Case &HC52
				CardName.Text = "PCIe-DIO-24 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE53
				CardName.Text = "PCIe-DIO-24S Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HC53
				CardName.Text = "PCIe-DIO-24D Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE55
				CardName.Text = "PCIe-DIO-24DC Parallel Digital I/O Card w/Counter"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE54
				CardName.Text = "PCIe-DIO-24DS Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
			Case &HE56
				CardName.Text = "PCIe-DIO-24DCS Parallel Digital I/O Card w/Counter"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
				
			Case &HC61
				CardName.Text = "PCIe-DIO-48 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				Ports(0) = &H0
				Ports(1) = &H4
				found = True
			Case &HE61
				CardName.Text = "PCIe-DIO-48S Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				Ports(0) = &H0
				Ports(1) = &H4
				found = True
			Case &HC68
				CardName.Text = "PCI-DIO-72 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				found = True
			Case &HC70
				CardName.Text = "PCI-DIO-96 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				found = True
			Case &HC69
				CardName.Text = "P104-DIO-96 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				found = True
			Case &HC78
				CardName.Text = "PCI-DIO-120 Parallel Digital I/O Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				AddressList.Items.Add(("Group 1 Base Offset 4"))
				AddressList.Items.Add(("Group 2 Base Offset 8"))
				AddressList.Items.Add(("Group 3 Base Offset 12"))
				AddressList.Items.Add(("Group 4 Base Offset 16"))
				Ports(0) = &H0
				Ports(1) = &H4
				Ports(2) = &H8
				Ports(3) = &HC
				Ports(4) = &H10
				found = True
			Case &H2EE0
				CardName.Text = "PCIe-DIO24S-CTR12 Digital/Counter Card"
				AddressList.Items.Add(("Group 0 Base Offset 0"))
				Ports(0) = &H0
				found = True
				
				' PCI-DA12-2/4/6 cards Offset 20,21,22 HEX!!! Port A,B,C
			Case &H6C90
				CardName.Text = "PCI-DA12-2 Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
			Case &H6C98
				CardName.Text = "PCI-DA12-4 Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
			Case &H6CA0
				CardName.Text = "PCI-DA12-6 Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
				
				' PCI-DA12-8/16 cards Offset 20,21,22 HEX!!! Port A,B,C
			Case &H6CA8
				CardName.Text = "PCI-DA12-8 Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
			Case &H6CB0
				CardName.Text = "PCI-DA12-16 Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
				
				' V series (Note: not yet tested)
			Case &H6CA9
				CardName.Text = "PCI-DA12-8V Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
			Case &H6CB1
				CardName.Text = "PCI-DA12-16V Digital to Analog Output Card"
				CheckTSTMode.CheckState = System.Windows.Forms.CheckState.Checked
				CheckTSTMode.Enabled = False
				AddressList.Items.Add(("Group 0 Base Offset 20"))
				Ports(0) = &H20
				found = True
				
				
		End Select
		
NoCards: 
		If Not found Then
			CardName.Text = "No Card Found"
			Memo1.Text = "No Card Found!" & Chr(13) & Chr(10) & "This may mean that the card is not installed, or the card is not 8255 equipped" & Chr(13) & Chr(10)
			Memo1.SelectionStart = 32768
			AddressList.Enabled = False
			RunFlag = False
		End If
		If RunFlag Then
			AddressList.SelectedIndex = 0
			Offset = Ports(AddressList.SelectedIndex) ' use indexed value to set offset
		End If
		
	End Sub
	
	Private Sub PerformButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles PerformButton.Click
		If Timer1.Enabled Then
			Timer1.Enabled = False
			PerformButton.Text = "Perform I/O"
		Else
			Timer1.Enabled = True
			RelOutPortB(Cardnum, Offset + 3, &H82) ' write control register, 100000010, set B Input, A Output and mode etc
			If CheckTSTMode.CheckState Then
				RelOutPortB(Cardnum, Offset + 3, &H2) ' write control register, 000000010, toggle B7 ctrl reg bit
			End If
			PerformButton.Text = "Stop I/O"
		End If
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		Dim i As Object
		Dim j As Short
		
		MyValues(0) = 2 ^ MyIndex
		RelOutPortB(Cardnum, Offset + 0, MyValues(0)) 'relative offset
		
		
		' Changed to use relative functions  RelInPortB(Cardnum, Port)
		' using local Offset parameter which is now set to the appropriate offset from Base address ie 0 for Group 0 or 4 for Group 1 etc
		' adding offset in this case using 0 for Group 0 port A and 1 for Group 0 port B:
		' so this will read  A and B inputs values even though A is set for output we can read/veify its value
		MyValues(1) = RelInPortB(Cardnum, Offset + 0)
		MyValues(2) = RelInPortB(Cardnum, Offset + 1)
		
		MyIndex = MyIndex + 1
		MyIndex = MyIndex Mod 8
		
		Msg = ""
		For j = 7 To 0 Step -1
			If (MyValues(0) And (2 ^ j)) > 0 Then
				Msg = Msg & "1"
			Else
				Msg = Msg & "0"
			End If
		Next 
		PortAOut.Text = Msg
		Msg = ""
		For j = 7 To 0 Step -1
			If (MyValues(1) And (2 ^ j)) > 0 Then
				Msg = Msg & "1"
			Else
				Msg = Msg & "0"
			End If
		Next 
		PortAIn.Text = Msg
		Msg = ""
		For j = 7 To 0 Step -1
			If (MyValues(2) And (2 ^ j)) > 0 Then
				Msg = Msg & "1"
			Else
				Msg = Msg & "0"
			End If
		Next 
		PortBIn.Text = Msg
	End Sub
End Class